package com.jtyjy.pdf2pptx.converter;

import com.jtyjy.pdf2pptx.support.Constant;
import com.jtyjy.pdf2pptx.support.FileUtil;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Component;

import java.io.File;
import java.util.ArrayList;
import java.util.List;
/**
 * pdf转pptx
 * 常量Constant.SOURCE_PATH为待转换文件根目录
 *
 * @author guan
 */
@Component
public class Pdf2Pptx {

    private static final Logger logger = LoggerFactory.getLogger(Pdf2Pptx.class);

    public static void main(String[] args) {
        //读取指定文件夹下所有文件并转换为图片
//        conver(Constant.SOURCE_PATH);
    }

    public void converte(String path){
        conver(path);
    }

    private static void conver(String path) {
        //读取指定文件夹下所有文件并转换为图片
        List<String> allFilePathName = new ArrayList<>();

        FileUtil.getAllFilePathNameRe(path, allFilePathName);
        for (String filePathName : allFilePathName) {
            File file = new File(filePathName);
            if (file.getName().endsWith(".pdf")) {
                //判断图片是否存在
                List<String> allDirPathName = new ArrayList<>();
                FileUtil.getAllDirPathNameRe(path, allDirPathName);
                if (!allDirPathName.contains(file.getAbsolutePath().replace(".pdf", "_图片"))) {
                    logger.info("转换pdf：{} 为图片开始", file.getAbsolutePath());
                    long begin = System.currentTimeMillis();
                    Pdf2Png.pdf2Image(file.getAbsolutePath(), file.getParent(), 350);
                    long end = System.currentTimeMillis();
                    logger.info("转换pdf：{} 为图片完成，耗时{}ms", file.getAbsolutePath(), end - begin);
                } else {
                    logger.info("文件：{} 已经转换", file.getName());
                }
            }
        }
        logger.info("======== pdf转图片已完成，准备生成pptx ========");
        try {
            Thread.sleep(5000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        //将图片插入PPT
        List<String> allDirPathName = new ArrayList<>();
        FileUtil.getAllDirPathNameRe(path, allDirPathName);
        for (String dirPathName : allDirPathName) {
            File dir = new File(dirPathName);
            //判断ppt是否存在
            if (dir.getName().endsWith("_图片")) {
                List<String> allPptPathFileName = new ArrayList<>();
                FileUtil.getAllFilePathNameRe(path, allPptPathFileName);
                if (!allPptPathFileName.contains(dir.getAbsolutePath().replace("_图片", ".pptx"))) {
                    List<String> filePathNames = FileUtil.getAllFilePathName(dir.getAbsolutePath());
                    //转换
                    logger.info("开始转换图片：{} 为pptx", dir.getName());
                    long begin = System.currentTimeMillis();
                    Png2Pptx.createPicturePptx(filePathNames, dir);
                    long end = System.currentTimeMillis();
                    logger.info("转换图片：{} 为pptx完成,耗时：{}ms", dir.getName(), end - begin);
                } else {
                    logger.info("文件：{} 已经存在", dir.getName() + ".pptx");
                }
            }

        }
    }

}
