package com.jtyjy.pdf2pptx.support;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

public class FileUtil {

    /**
     * 获取某个文件夹下的所有文件全路径名
     *
     * @param path 文件夹的路径
     * @return
     */
    public static List<String> getAllFilePathName(String path) {
        List<String> fileNameList = new ArrayList<String>();
        boolean flag = false;
        File file = new File(path);
        File[] tempList = file.listFiles();

        for (int i = 0; i < tempList.length; i++) {
            if (tempList[i].isFile()) {
                fileNameList.add(tempList[i].getAbsolutePath());
            }
            /*if (tempList[i].isDirectory()) {
                getAllFileName(tempList[i].getAbsolutePath(),fileNameList);
            }*/
        }
        return fileNameList;
    }

    /**
     * 获取某个文件夹下的所有文件全路径名
     *
     * @param path 文件夹的路径
     * @return
     */
    public static List<File> getAllFiles(String path) {
        List<File> fileList = new ArrayList<>();
        boolean flag = false;
        File file = new File(path);
        File[] tempList = file.listFiles();

        for (int i = 0; i < tempList.length; i++) {
            if (tempList[i].isFile()) {
                fileList.add(tempList[i]);
            }
            /*if (tempList[i].isDirectory()) {
                getAllFileName(tempList[i].getAbsolutePath(),fileNameList);
            }*/
        }
        return fileList;
    }

    /**
     * 获取某个文件夹下的所有文件名
     *
     * @param path 文件夹的路径
     * @return
     */
    public static List<String> getAllFileName(String path) {
        List<String> fileNameList = new ArrayList<String>();
        boolean flag = false;
        File file = new File(path);
        File[] tempList = file.listFiles();
        for (int i = 0; i < tempList.length; i++) {
            if (tempList[i].isFile()) {
                fileNameList.add(tempList[i].getName());
            }
            /*if (tempList[i].isDirectory()) {
                getAllFileName(tempList[i].getAbsolutePath(),fileNameList);
            }*/
        }
        return fileNameList;
    }

    /**
     * 获取某个文件夹下的所有文件夹全路径名
     *
     * @param path 文件夹的路径
     * @return
     */
    public static List<String> getAllDirPathName(String path) {
        List<String> dirNameList = new ArrayList<String>();
        File file = new File(path);
        File[] tempList = file.listFiles();
        for (int i = 0; i < tempList.length; i++) {
            if (tempList[i].isDirectory()) {
                dirNameList.add(tempList[i].getAbsolutePath());
            }
            /*if (tempList[i].isDirectory()) {
                getAllFileName(tempList[i].getAbsolutePath(),fileNameList);
            }*/
        }
        return dirNameList;
    }

    /**
     * 获取某个文件夹下的所有文件夹名
     *
     * @param path 文件夹的路径
     * @return
     */
    public static List<String> getAllDirName(String path) {
        List<String> dirNameList = new ArrayList<String>();
        File file = new File(path);
        File[] tempList = file.listFiles();
        for (int i = 0; i < tempList.length; i++) {
            if (tempList[i].isDirectory()) {
                dirNameList.add(tempList[i].getName());
            }
            /*if (tempList[i].isDirectory()) {
                getAllFileName(tempList[i].getAbsolutePath(),fileNameList);
            }*/
        }
        return dirNameList;
    }

    /**
     * 获取某个文件夹下的所有文件夹名
     *
     * @param path 文件夹的路径
     * @return
     */
    public static List<String> getAllDirNameRe(String path, List<String> dirNameList) {
        File file = new File(path);
        File[] tempList = file.listFiles();
        if (tempList != null) {
            for (int i = 0; i < tempList.length; i++) {
                if (tempList[i].isDirectory()) {
                    dirNameList.add(tempList[i].getName());
                    getAllDirNameRe(tempList[i].getAbsolutePath(), dirNameList);
                }
            }
        }
        return dirNameList;
    }

    /**
     * 获取某个文件夹下的所有文件夹
     *
     * @param path 文件夹的路径
     * @return
     */
    public static List<File> getAllDirs(String path) {
        List<File> dirNameList = new ArrayList<File>();
        File file = new File(path);
        File[] tempList = file.listFiles();
        for (int i = 0; i < tempList.length; i++) {
            if (tempList[i].isDirectory()) {
                dirNameList.add(tempList[i]);
            }
            /*if (tempList[i].isDirectory()) {
                getAllFileName(tempList[i].getAbsolutePath(),fileNameList);
            }*/
        }
        return dirNameList;
    }

    /**
     * 获取某个文件夹下的所有文件全路径名
     *
     * @param path 文件夹的路径
     * @return
     */
    public static List<String> getAllFilePathNameRe(String path, List<String> fileNameList) {
        File file = new File(path);
        File[] tempList = file.listFiles();
        if (tempList != null) {
            for (int i = 0; i < tempList.length; i++) {
                if (tempList[i].isFile()) {
                    fileNameList.add(tempList[i].getAbsolutePath());
                }
                if (tempList[i].isDirectory()) {
                    getAllFilePathNameRe(tempList[i].getAbsolutePath(), fileNameList);
                }
            }
        }
        return fileNameList;
    }

    /**
     * 获取某个文件夹下的所有文件夹全路径名
     *
     * @param path 文件夹的路径
     * @return
     */
    public static List<String> getAllDirPathNameRe(String path, List<String> dirNameList) {
        File file = new File(path);
        File[] tempList = file.listFiles();
        if (tempList != null) {
            for (int i = 0; i < tempList.length; i++) {
                if (tempList[i].isDirectory()) {
                    dirNameList.add(tempList[i].getAbsolutePath());
                    getAllDirPathNameRe(tempList[i].getAbsolutePath(), dirNameList);
                }
            }
        }
        return dirNameList;
    }

    public static void main(String[] args) {
        List<String> allDirPathName = getAllDirPathName("F:\\pdf图片");
        for (String s : allDirPathName) {
            System.out.println(s);
        }
    }


}
